$regfile = "m8def.dat"
$crystal = 2000000

'Konfiguracja portow
Ddrc = &B00000000                                           'wszystkie piny portu C jako wejscia
Portc = &B11111111                                          'wszystkie piny portu C podciagniete do zasilania
Config Pind.1 = Input                                       'linia danych jako wejscie
Config Pind.2 = Input                                       'linia zegara jako wejscie, int0
Set Portd.1                                                 'linia danych podciagnieta do zasilania
Set Portd.2                                                 'linia zegara podciagnieta do zasilania
Config Pind.5 = Output                                      'LED1
Config Pind.6 = Output                                      'LED2
Config Pind.7 = Output                                      'LED3
Config Pinb.0 = Output                                      'Laser
Config Pinb.1 = Output                                      'wyjscie PWM
Config Pinb.2 = Output                                      'wyjscie PWM

'deklaracja zmiennych, funkcji...
Dim Dane As Byte
Dim Licznik As Byte
Dim Parity As Byte
Dim Byte_status As Byte
Dim Byte1 As Byte
Dim Byte2 As Byte
Dim Byte3 As Byte
Dim Dzielnik As Byte
Dim Wskaznik As Bit
Dim Test_serw As Integer
Declare Sub Send_ps2_mouse(byval Command As Byte)
Declare Function Read_ps2_mouse() As Byte
Declare Sub X_decr
Declare Sub Y_decr
Declare Sub X_incr
Declare Sub Y_incr
Declare Sub Skalowanie

'ustawienie aliasow
Led1 Alias Portd.5
Led2 Alias Portd.6
Led3 Alias Portd.7
Laser Alias Portb.0

'wygaszenie LED i lasera
Set Led1
Set Led2
Set Led3
Set Laser

' Konfiguracja PWM
Tccr1a = &B10100000                                         'tryb phase and frequency correct, TOP = ICR1
Tccr1b = &B00010001                                         'tryb phase and frequency correct, preskaler 1 (trzy ostatnie bity)
'Ustalenie czestotliwosci PWM
'f=clk/2/preskaler/top
'f=50 Hz dla okresu 20 ms
'top=clk/2/preskaler/f
'top=2000000/2/1/50
'top=20000
Icr1 = 20000

'dla 10 ms ocr1x =10000
'dla 1 ms ocr1x=1000
'dla 2 ms ocr1x=2000

'test ukladu
Reset Led1                                                  'zaswiec LEDy
Reset Led2
Reset Led3
Ocr1a = 1000                                                'wstepne ustawienie serw w skrajnej pozycji
Ocr1b = 1000
Wait 1
'test osi poziomej
For Test_serw = 1000 To 2000
   Ocr1a = Test_serw
   Waitms 2
Next Test_serw
For Test_serw = 2000 To 1000 Step -1
   Ocr1a = Test_serw
   Waitms 2
Next Test_serw
'koniec testu osi poziomej
'test osi pionowej
For Test_serw = 1500 To 2000
   Ocr1b = Test_serw
   Waitms 2
Next Test_serw
For Test_serw = 2000 To 1500 Step -1
   Ocr1b = Test_serw
   Waitms 2
Next Test_serw
'koniec testu osi pionowej
Ocr1a = 1500                                                'ustawienie serw w pozycji srodkowej
Ocr1b = 1750

Set Led1                                                    'wylacz LEDy
Set Led2
Set Led3
'koniec testu ukladu

Readeeprom Dzielnik , 0                                     'odczytanie wspolczynnika skalowania z pamieci EEPROM
If Dzielnik = 0 Then                                        'jesli 0
   Dzielnik = 2                                             'to ustawienie domyslnej wartosci
End If
If Dzielnik > 7 Then                                        'jesli > 7
   Dzielnik = 2                                             'to ustawienie domyslnej wartosci
End If

Waitms 10
Call Send_ps2_mouse($f0)                                    'tryb: remote mode, mysz przesyla dane, kiedy chce tego urzadzenie nadrzedne
Waitms 10

Do
   Call Send_ps2_mouse($eb)                                 'polecenie odczytu danych z myszy
   Byte_status = Read_ps2_mouse()                           'odczyt bajtu potwierdzenia
   Byte1 = Read_ps2_mouse()                                 'odczyt bajtu statusu
   Byte2 = Read_ps2_mouse()                                 'odczyt bajtu ruchu X
   Byte3 = Read_ps2_mouse()                                 'odczyt bajtu ruchu Y

   If Byte1.2 = 1 Then                                      'jezeli nacisnieto srodkowy przycisk myszy
      Call Skalowanie                                       'wywolaj podprogram skalowania
   End If
   If Byte1.0 = 1 Then                                      'jesli nacisnieto lewy przycisk myszy
      Toggle Laser                                          'wlacz/wylacz laser
      Toggle Led1                                           'zaswiec LED1
      Waitms 200                                            'odczekaj, aby nie "mrugac" laserem
   End If

   'sprawdzenie bitow kierunku ruchu myszy
   If Byte1.4 = 1 Then
      Byte2 = 255 - Byte2
      Byte2 = Byte2 \ Dzielnik
      Call X_incr
   End If
   If Byte1.5 = 1 Then
      Byte3 = 255 - Byte3
      Byte3 = Byte3 \ Dzielnik
      Call Y_incr
   End If
   If Byte1.4 = 0 Then
      Byte2 = Byte2 \ Dzielnik
      Call X_decr
   End If
   If Byte1.5 = 0 Then
      Byte3 = Byte3 \ Dzielnik
      Call Y_decr
   End If
Loop

'podprogram wysylania danych do myszy
Sub Send_ps2_mouse(byval Command As Byte)
   'pind.1 - dane
   'pind.2 - zegar
   Parity = Command.0 Xor Command.1                         'obliczenie bitu parzystosci
   Parity = Parity Xor Command.2
   Parity = Parity Xor Command.3
   Parity = Parity Xor Command.4
   Parity = Parity Xor Command.5
   Parity = Parity Xor Command.6
   Parity = Parity Xor Command.7
   Parity = Not Parity                                      'bo Parity musi byc rowne 1 dla parzystej liczby jedynek
   Config Pind.1 = Output                                   'linia danych jako wyjsciowa
   Config Pind.2 = Output                                   'linia zegara jako wyjsciowa
   Set Portd.1
   Reset Portd.2                                            'wyslanie request to send
   Waitus 200
   Reset Portd.1
   Waitus 50
   Config Pind.2 = Input                                    'linia zegara jako wejsciowa
   Set Portd.2                                              'linia zegara podciagnieta do zasilania
   Bitwait Pind.2 , Set
   Bitwait Pind.2 , Reset                                   'odczekanie na stan niski linii zegara
   For Licznik = 0 To 7                                     'wyslanie osmiu bitow danych
      Portd.1 = Command.licznik                             'wystawienie bitu danych
      Bitwait Pind.2 , Set                                  'i odczekanie na cykl zegara
      Bitwait Pind.2 , Reset
   Next Licznik
   Portd.1 = Parity                                         'wyslanie bitu parzystosci
   Bitwait Pind.2 , Set
   Bitwait Pind.2 , Reset
   Portd.1 = 1                                              'wyslanie bitu stopu
   Bitwait Pind.2 , Set
   Config Pind.1 = Input                                    'linia danych jako wejsciowa
   Set Portd.1                                              'linia danych podciagnieta do zasilania
   Bitwait Pind.2 , Reset                                   'odczekanie na bit ACK od myszy
   Bitwait Pind.2 , Set
End Sub

'funkcja odbierajaca dane od myszy
Function Read_ps2_mouse() As Byte
   Local Dane_odebrane As Byte                              'zmienna lokalna, tylko na potrzeby funkcji
   Dane_odebrane = 0                                        'wyzerowanie zmiennej
   Bitwait Pind.2 , Reset                                   'pierwsze zbocze opadajce linii zegara, START
   For Licznik = 0 To 7                                     'odczytanie osmiu bitow danych
      Bitwait Pind.2 , Set                                  'odczekanie na stan wysoki linii zegara
      Bitwait Pind.2 , Reset                                'odczekanie na stan niski linii zegara
      Dane_odebrane.licznik = Pind.1                        'i odczytanie bitu danych
   Next Licznik
   Bitwait Pind.2 , Set                                     'odczekanie na bit parzystosci, ale bez jego rejestracji
   Bitwait Pind.2 , Reset
   Bitwait Pind.2 , Set                                     'odczekanie na bit stopu, ale bez jego rejestracji
   Bitwait Pind.2 , Reset
   Bitwait Pind.2 , Set                                     'odczekanie na nieaktywny stan linii zegara, koniec ramki danych
   Read_ps2_mouse = Dane_odebrane                           'podstawienie za wartosc funkcji odebranych danych
End Function


'podprogram zwiekszenia wspolczynnika wypelnienia dla 1 kanalu PWM
Sub X_incr
   Ocr1a = Ocr1a + Byte2                                    'zwiekszenie wspolczynnika wypelnienia dla 1 kanalu PWM
   If Ocr1a > 2000 Then
      Ocr1a = 2000
   End If
   Byte2 = 0                                                'wyzerowanie zmiennej zawierajcej warto ruchu X
End Sub

'podprogram zwiekszenia wspolczynnika wypelnienia dla 2 kanalu PWM
Sub Y_incr
   Ocr1b = Ocr1b + Byte3                                    'zwiekszenie wspolczynnika wypelnienia dla 2 kanalu PWM
   If Ocr1b > 2000 Then
      Ocr1b = 2000
   End If
   Byte3 = 0                                                'wyzerowanie zmiennej zawierajacej wartosc ruchu Y
End Sub

'podprogram zmniejszenia wspolczynnika wypelnienia dla 1 kanalu PWM
Sub X_decr
   Ocr1a = Ocr1a - Byte2                                    'zmniejszenie wspolczynnika wypelnienia dla pierwszego kanalu PWM
   If Ocr1a < 1000 Then
      Ocr1a = 1000
   End If
   Byte2 = 0                                                'wyzerowanie zmiennej zawierajacej wartosc ruchu X
End Sub

'podprogram zmniejszenia wspolczynnika wypelnienia dla 2 kanalu PWM
Sub Y_decr
   Ocr1b = Ocr1b - Byte3                                    'zmniejszenie wspolczynnika wypelnienia dla 2 kanalu PWM
   If Ocr1b < 1500 Then
      Ocr1b = 1500
   End If
   Byte3 = 0                                                'wyzerowanie zmiennej zawierajacej wartosc ruchu Y
End Sub

'podprogram ustawienia wspolczynnika skalowania
Sub Skalowanie
   Wskaznik = 0                                             'wyzerowanie wskaznika zakonczenia petli
   Dzielnik = 2                                             'ustawienie domyslnej wartosci wspolczynnika skalowania
   Set Laser                                                'wylacz laser
   Do
      Call Send_ps2_mouse($eb)                              'read data
      Byte_status = Read_ps2_mouse()                        'odczyt bajtu potwierdzenia, niewykorzytywany
      Byte1 = Read_ps2_mouse()                              'odczyt bajtu statusu
      Byte2 = Read_ps2_mouse()                              'odczyt bajtu ruchu X, tutaj niewykorzystywany
      Byte3 = Read_ps2_mouse()                              'odczyt bajtu ruchu Y, tutaj niewykorzystywany
      If Byte1.0 = 1 Then                                   'jesli nacisnieto lewy przycisk myszy
         Dzielnik = Dzielnik + 1                            'zwieksz wartosc wspolczynnika
         If Dzielnik > 7 Then                               'jesli wartosc ta bedzie wieksza od 7
            Dzielnik = 0                                    '"przewin" do poczatku
         End If
      End If
      If Byte1.1 = 1 Then                                   'jezeli nacisnieto prawy przycisk myszy
         Wskaznik = 1                                       'ustaw zmienna "Wskaznik"
      End If
      Waitms 200
      Led1 = Not Dzielnik.2                                 'wyswietlenie wybranej wartosci
      Led2 = Not Dzielnik.1                                 'NOT, poniewaz LED sterowane s logicznym zerem
      Led3 = Not Dzielnik.0
   Loop Until Wskaznik = 1                                  'jesli wskaznik=1, to zakoncz petle
   Writeeeprom Dzielnik , 0                                 'wpisanie ustawionej wartosci do pamieci EEPROM
   Set Led1                                                 'wygaszenie LED
   Set Led2
   Set Led3
End Sub                                                     'koniec podprogramu